#!/bin/bash
echo "G92.1 G54 G49"
echo "G90"
echo "G64 P0.005"
echo "F100"

sed '
s|\[|(|g
s|]|)|g
s|L12ZZ|o<zz> call|g
s|L12|o<unslave> call|g
s|M98 ON.MAC|o<on>call|
s|M98 OFF.MAC|M5|
s|G91||gi
s|G00 Y-48.0 [Xx]0 F400|G0 X0 Y0|g
s|G00 Y-48 [Xx]0 F400|G0 X0 Y0|g
/L10 R\(.*\) C\(.*\) X\(.*\) Y\(.*\)/ a\
o100 sub
/L10 R/ {
s|Y|\n#4=|
s|X|\n#3=|
s|C|\n#2=|
s|L10 R|#1=|
}
/L10/ c\
o100 endsub\
o102 repeat [#1] (number of rows Y repeats)\
o103 repeat [#2] (number of columns X repeats)\
o100 call\
G0 X#3 Y0 (width of columns)\
G92 X0Y0\
o103 end repeat\
G0 X[#3*-#2]\
G92X0\
G0 X0 Y#4 (length of rows)\
G92 X0Y0\
o102 endrepeat\
G92.1\
' "$1"

echo "G49 G92.1"
echo "M30"
echo "%"
